import { OnChanges, SimpleChanges } from '@angular/core';
import moment from 'moment';
import { BaseSelect } from './base.select';
import { MomentPipe } from '../pipes/moment';
export interface RangeDate {
    start: moment.Moment;
    end: moment.Moment;
}
export declare class RangeSelectDirective extends BaseSelect<RangeDate> implements OnChanges {
    private momentPipe;
    protected readonly EMPTY_VALUE: RangeDate;
    constructor(momentPipe: MomentPipe);
    setValue(value: RangeDate): void;
    setStartDate(date: moment.Moment): void;
    setEndDate(date: moment.Moment): void;
    ngOnChanges(changes: SimpleChanges): void;
    selectDate(date: moment.Moment): boolean;
    unselectDate(date: moment.Moment): boolean;
    isDateSelected(date: moment.Moment): boolean;
    isDateInSelectRange(date: moment.Moment): boolean;
    isComplete(): boolean;
    toString(format: string, locale: string): string;
}
